package art;
import java.awt.*;

public class DriveArt extends AnimatedArt
{
    private int fireSize = 1;
    
    public DriveArt()
    {
        animation.setLoopBehavior(Animation.LOOP_BACK_FORTH);
        animation.setLoopRepeatBehavior(Animation.LOOP_REPEAT_FOREVER);
        animation.setMaxCell(10);
    }

    public void turnOnFire()
    {
        fireSize = 4;
    }
    public void turnOffFire()
    {
        fireSize = 1;
    }

    protected int getMaxPoints()
    {
        return 3;
    }

    protected void setPolyShape(int cell)
    {
        polyX[0] = grid.mid.x - (int) cell/2;
        polyY[0] = grid.rect.bottom;

        polyX[1] = grid.mid.x + (int) cell/2;
        polyY[1] = grid.rect.bottom;

        polyX[2] = grid.mid.x;
        polyY[2] = grid.rect.bottom + cell*fireSize;
    }

    protected void setPolyColor(int cell)
    {
        setColor(100+cell*15, 50+cell*10, 10+cell*5);
    }
}
