package game;
import java.awt.*;

public class Earth extends Thing
{
    private final static int maxPoints = 20;
    private int polyX[] = new int[maxPoints+1];
    private int polyY[] = new int[maxPoints+1];

    public Earth()
    {
        super( 86, 86 );
        position(2000, 1500);
    }

    private void setPoly()
    {
        int i = 0;
        polyX[i] = 13; polyY[i++] = 32;
        polyX[i] = 13; polyY[i++] = 13;
        polyX[i] = 21; polyY[i++] =  7;
        polyX[i] = 40; polyY[i++] =  7;
        polyX[i] = 33; polyY[i++] = 13;
        polyX[i] = 41; polyY[i++] = 18;
        polyX[i] = 44; polyY[i++] = 11;
        polyX[i] = 57; polyY[i++] = 19;
        polyX[i] = 39; polyY[i++] = 34;
        polyX[i] = 28; polyY[i++] = 33;
        polyX[i] = 27; polyY[i++] = 36;
        polyX[i] = 41; polyY[i++] = 44;
        polyX[i] = 54; polyY[i++] = 43;
        polyX[i] = 74; polyY[i++] = 55;
        polyX[i] = 45; polyY[i++] = 81;
        polyX[i] = 46; polyY[i++] = 62;
        polyX[i] = 39; polyY[i++] = 54;
        polyX[i] = 42; polyY[i++] = 47;
        polyX[i] = 21; polyY[i++] = 40;
        polyX[i] = 14; polyY[i++] = 32;
    }

    public void appear(Graphics graph, Ground ground, Camera camera)
    {
        int offX = 0, offY = 0;
        offX = getAppearX(ground, camera);
        offY = getAppearY(ground, camera);
        drawGlobe(graph, offX, offY);
        drawContinent(graph, offX, offY);
    }

    private void drawGlobe(Graphics graph, int offX, int offY)
    {
        final int offSize = 10, innerOffColor = 30;
        graph.setColor( new Color(52-innerOffColor, 126-innerOffColor, 188-innerOffColor) );
        graph.fillOval( offX, offY, size.width, size.height );

        graph.setColor( new Color(52, 126, 188) );
        graph.fillOval( offX, offY,
            size.width-offSize, size.height-offSize );
    }

    private void drawContinent(Graphics graph, int offX, int offY)
    {
        graph.setColor( new Color (191, 155, 115) );
        setPoly();
        setPolyOffset(offX, offY);
        graph.fillPolygon(polyX, polyY, maxPoints);
    }

    private void setPolyOffset(int offX, int offY)
    {
        int i;
        for (i = 0; i <= maxPoints; i++)
        {
            polyX[i] += offX;
            polyY[i] += offY;
        }
    }
}