package game;

public class IntelligentMovingThing extends MovingThing
{
    final double
        FOLLOW_ADJUST_SPEED = getFollowAdjustSpeed(),
        FOLLOW_MAX_SPEED = getFollowMaxSpeed();

    public IntelligentMovingThing(int _width, int _height, int red, int green, int blue)
    {
        super(_width, _height, red, green, blue);
    }
    public IntelligentMovingThing(int _width, int _height)
    {
        super(_width, _height);
    }
    
    protected int getFollowAdjustSpeed()
    {
        return 2;
    }
    protected int getFollowMaxSpeed()
    {
        return 7;
    }

    public void follow(int targetX, int targetY)
    {
        boolean foundBothXY = false;
        foundBothXY = followPoint( new shape.Point(targetX, targetY), new shape.Size() );
    }
    public void follow(shape.Point point)
    {
        boolean foundBothXY = false;
        foundBothXY = followPoint( point, new shape.Size() );
    }
    public void follow(shape.Point point, shape.Size margin)
    {
        boolean foundBothXY = false;
        foundBothXY = followPoint( point, margin );
    }

    private boolean followPoint(shape.Point target, shape.Size margin)
    {
        boolean foundX = false, foundY = false;
        foundX = followPointX(target, margin);
        foundY = followPointY(target, margin);

        if ( foundX ) speedX = slowDown(speedX);
        if ( foundY ) speedY = slowDown(speedY);

        return foundX && foundY;
    }

    private boolean followPointX(shape.Point target, shape.Size margin)
    {
        boolean foundX = false;

        if ( target.x+margin.width < x )
        {
            if ( speedX-FOLLOW_ADJUST_SPEED > -FOLLOW_MAX_SPEED )
                speedX -= FOLLOW_ADJUST_SPEED;
        }
        else if ( target.x-margin.width > x )
        {
            if ( speedX+FOLLOW_ADJUST_SPEED < FOLLOW_MAX_SPEED )
                speedX += FOLLOW_ADJUST_SPEED;
        }
        else foundX = true;
        return foundX;
    }
    private boolean followPointY(shape.Point target, shape.Size margin)
    {
        boolean foundY = false;

        if ( target.y+margin.height < y )
        {
            if ( speedY-FOLLOW_ADJUST_SPEED > -FOLLOW_MAX_SPEED )
                speedY -= FOLLOW_ADJUST_SPEED;
        }
        else if ( target.y-margin.height > y )
        {
            if ( speedY+FOLLOW_ADJUST_SPEED < FOLLOW_MAX_SPEED )
                speedY += FOLLOW_ADJUST_SPEED;
        }
        else foundY = true;
        return foundY;
    }
}