package game;
import java.awt.*;
import java.awt.image.*;

public class Thing
{
    protected double x = 0, y = 0;
    protected shape.Size size = new shape.Size();
    protected Color col;

    public Thing(int _width, int _height, int red, int green, int blue)
    {
        col = new Color(red, green, blue);
        size.width = _width;
        size.height = _height;
    }
    public Thing(shape.Size _size, int red, int green, int blue)
    {
        col = new Color(red, green, blue);
        size.width = _size.width;
        size.height = _size.height;
    }
    public Thing(int _width, int _height)
    {
        col = new Color(255, 255, 255);
        size.width = _width;
        size.height = _height;
    }

    public int getWidth()
    {
        return size.width;
    }

    public int getHeight()
    {
        return size.height;
    }

    public void appear(Graphics graph, Ground ground, Camera camera)
    {
        graph.setColor(col);
        graph.fillRect
        (
            getAppearX(ground, camera), getAppearY(ground, camera),
            size.width, size.height
        );
    }
    public int getAppearX(Ground ground, Camera camera)
    {
        return (int) ( x+ground.getOffsetX() - camera.getViewLeft() );
    }
    public int getAppearY(Ground ground, Camera camera)
    {
        return (int) ( y+ground.getOffsetY() - camera.getViewTop() );
    }

    public void randPos(int maxX, int maxY)
    {
        x = (int) ( Math.random()* (maxX- size.width*2) ) +size.width;
        y = (int) ( Math.random()* (maxY- size.height*2) ) +size.height;
    }

    public void randPosRect(int offX, int offY, int maxX, int maxY)
    {
        x = (int) ( Math.random()* (maxX- size.width*2) ) +size.width +offX;
        y = (int) ( Math.random()* (maxY- size.height*2) ) +size.height +offY;
    }

    public shape.Point getPosition()
    {
        return new shape.Point(x, y);
    }

    public void position(int _x, int _y)
    {
        x = _x;
        y = _y;
    }

    public void position(shape.Point pos)
    {
        x = pos.x;
        y = pos.y;
    }

    public void position(shape.PointInt pos)
    {
        x = (double) pos.x;
        y = (double) pos.y;
    }

}
