package math;

public class Number
{
    private int number = 0;
    private boolean hasMaximum = false, hasMinimum = false;
    private int minimum = 0, maximum = 255;
    private int randomization = 10;

    public Number(int _number)
    {
        number = _number;
    }
    public Number(double _number)
    {
        number = (int) _number;
    }
    public Number()
    {
        number = 0;
    }

    public void setMinMax(int _minimum, int _maximum)
    {
        setMinimum(_minimum);
        setMaximum(_maximum);
    }

    public void setMinimum(int _minimum)
    {
        hasMinimum = true;
        minimum = _minimum;
        increaseToMinimum();
    }
    public void removeMinimum()
    {
        hasMinimum = false;
    }
    public void setMaximum(int _maximum)
    {
        hasMaximum = true;
        maximum = _maximum;
        reduceToMaximum();
    }
    public void removeMaximum()
    {
        hasMaximum = false;
    }

    private void adjustToMinMax()
    {
        reduceToMaximum();
        increaseToMinimum();
    }

    private void reduceToMaximum()
    {
        if ( hasMaximum )
            number = number > maximum ? maximum : number;
    }
    private void increaseToMinimum()
    {
        if ( hasMinimum )
            number = number < minimum ? minimum : number;
    }

    public void setRandomization(int _randomization)
    {
        randomization = _randomization;   
    }

    public int getRandomizedValue()
    {
        int r_num = 0;
        r_num = randomizeFromTo(
                (int) number - randomization / 2,
                (int) number + randomization / 2 );
        if ( hasMaximum )
            r_num = r_num > maximum ? maximum : r_num;
        if ( hasMinimum )
            r_num = r_num < minimum ? minimum : r_num;
        return r_num;
    }

    private int randomizeFromTo(int from, int to)
    {
        return randomInt(to-from) + from;
    }

    private int randomInt(int amount)
    {
        return (int) (Math.random() * amount);
    }

    public void setValue(int value)
    {
        number = value;
        adjustToMinMax();
    }

    public int getValue()
    {
        return number;
    }
}
